-- generateur de frequence type DDS


library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
use ieee.numeric_std.all;

entity DDS is
   port(
      clk: in std_logic;
      dn: in std_logic_vector(31 downto 0);
      clk_out : out std_logic
		);
end entity;

architecture behavior of DDS is
signal a,b,c:std_logic_vector(31 downto 0);
signal clko : std_logic;
begin
DFLIPFLOP1:process(clk) begin
	if rising_edge(clk) then
		a<=c;
	end if;
end process;

DFLIPFLOP:process(clk) begin
	if rising_edge(clk) then
		b<=dn;
	end if;
end process;

SUM:process(a,b) begin
	c<=('0' & a(30 downto 0)) + ('0' & b(30 downto 0));
end process;

DIV2:process(clk) begin
	if rising_edge(clk) then
		if a(31)='1' then
			clko <= not clko;
		end if;
	end if;
end process;
	
clk_out <= clko;

end behavior;